/*

                                   _JNJ`                        
                               .JNMH`                           
                              JMMF`       `;.                   
                            .NMM)          `MN.                 
                            MMM)            (MML                
                           (MMM`             MMML               
                     M  I  D  N  I  G  H  T    C  o  D  E       
                           (NMMF             MHNH               
                            NMML            .MMM                
                             NMML          .NMH                 
                              4MMNL       .#F                   
                               `4HNNL_   `                      
                                   `"""`                        

                          Copyright (C) 2004-2005
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt

*/


/* midnightcode-route.h :: Midnight Code network route library	*/


#ifndef __MIDNIGHTCODE_ROUTE_H
#define __MIDNIGHTCODE_ROUTE_H


struct midnightcode_route_element_t
{
  int flags;
  int in_ifindex;
  int out_ifindex;
  int metric;
  int priority;
  int is_defaultroute;
  struct in_addr ipv4_prefsource;
  struct in_addr ipv4_source;
  struct in_addr ipv4_destination;
  struct in_addr ipv4_gateway;
  char in_ifname[64];
  char out_ifname[64];
  char ipv4_prefsource_s[32];
  char ipv4_source_s[32];
  char ipv4_destination_s[32];
  char ipv4_gateway_s[32];
  midnightcode_list_entry(midnightcode_route_element_t)
};


midnightcode_list_head(midnightcode_route_head_t,
                       midnightcode_route_element_t)


int midnightcode_route_listrecv(int sockfd, char *msgbuf, uint msgseq,
                            uint msgpid);
int midnightcode_route_listadd(
                            struct midnightcode_route_head_t * elements,
                            struct midnightcode_route_element_t * now_element,
                            void * msg_nlhdr);
int midnightcode_route_list(struct midnightcode_route_head_t * elements);


#endif
