/*

                                   _JNJ`                        
                               .JNMH`                           
                              JMMF`       `;.                   
                            .NMM)          `MN.                 
                            MMM)            (MML                
                           (MMM`             MMML               
                     M  I  D  N  I  G  H  T    C  o  D  E       
                           (NMMF             MHNH               
                            NMML            .MMM                
                             NMML          .NMH                 
                              4MMNL       .#F                   
                               `4HNNL_   `                      
                                   `"""`                        

                          Copyright (C) 2004-2005
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt

*/


/* midnightcode-switch.h :: Midnight Code command-line switch library	*/


#ifndef __MIDNIGHTCODE_SWITCH_H
#define __MIDNIGHTCODE_SWITCH_H


enum midnightcode_switch_style_t
{
  MIDNIGHTCODE_SWITCH_STYLE_SOFT = 1,
  MIDNIGHTCODE_SWITCH_STYLE_NORMAL,
  MIDNIGHTCODE_SWITCH_STYLE_STRONG,
  MIDNIGHTCODE_SWITCH_STYLE_UNKNOWN
};

enum midnightcode_switch_type_t
{
  MIDNIGHTCODE_SWITCH_TYPE_NONE = 1,
  MIDNIGHTCODE_SWITCH_TYPE_STRING,
  MIDNIGHTCODE_SWITCH_TYPE_INT,
  MIDNIGHTCODE_SWITCH_TYPE_LONG,
  MIDNIGHTCODE_SWITCH_TYPE_VAL,
  MIDNIGHTCODE_SWITCH_TYPE_FLOAT,
  MIDNIGHTCODE_SWITCH_TYPE_DOUBLE,
  MIDNIGHTCODE_SWITCH_TYPE_HOST,
  MIDNIGHTCODE_SWITCH_TYPE_IP
};

struct midnightcode_switch_t
{
  const char * short_s;
  const char * long_s;
  const char * descript_s;
  int type;
  int length;
  int value;
  void * variable;
};
  

int midnightcode_switch_usage(int style, char * execname,
                              struct midnightcode_switch_t * switches);
int midnightcode_switch_process(int argc, char** argv,
                                struct midnightcode_switch_t * switches);


#endif
